aboutsummaryrefslogtreecommitdiffstats
path: root/pkgs
diff options
context:
space:
mode:
Diffstat (limited to 'pkgs')
-rwxr-xr-xpkgs/by-name/ba/back/update.sh2
-rw-r--r--pkgs/default.nix22
-rwxr-xr-xpkgs/update_pkgs.sh44
3 files changed, 66 insertions, 2 deletions
diff --git a/pkgs/by-name/ba/back/update.sh b/pkgs/by-name/ba/back/update.sh
index 3247c21..c715a63 100755
--- a/pkgs/by-name/ba/back/update.sh
+++ b/pkgs/by-name/ba/back/update.sh
@@ -11,7 +11,5 @@
# You should have received a copy of the License along with this program.
# If not, see <https://www.gnu.org/licenses/agpl.txt>.
-nix flake update
-
[ "$1" = "upgrade" ] && cargo upgrade
cargo update
diff --git a/pkgs/default.nix b/pkgs/default.nix
new file mode 100644
index 0000000..e665eb2
--- /dev/null
+++ b/pkgs/default.nix
@@ -0,0 +1,22 @@
+{
+ pkgs,
+ nixLib,
+}: let
+ inherit (pkgs) lib;
+
+ warnMergeMessage = "the ./pkgs/by-name set";
+ wMM = warnMergeMessage;
+ callPackage =
+ lib.callPackageWith
+ (nixLib.warnMerge
+ pkgs
+ vhackPkgs
+ wMM);
+
+ vhackPkgs = nixLib.mkByName {
+ baseDirectory = ./by-name;
+ fileName = "package.nix";
+ finalizeFunction = name: value: callPackage value {};
+ };
+in
+ vhackPkgs
diff --git a/pkgs/update_pkgs.sh b/pkgs/update_pkgs.sh
new file mode 100755
index 0000000..3e33b72
--- /dev/null
+++ b/pkgs/update_pkgs.sh
@@ -0,0 +1,44 @@
+#!/usr/bin/env sh
+
+die() {
+ printf "\033[31;1mError: \033[0m%s\n" "$1"
+ exit 1
+}
+
+cd "$(dirname "$0")" || die "Bug: run with the wrong first arg: '$0'!"
+cd ./by-name || die "(BUG): The directory './by-name' does not exist?"
+
+# First check if all the update scripts conform to the standard
+files_with_update="$(mktemp)"
+trap 'rm "$files_with_update"' EXIT
+
+fd '^update.sh$' . --type file --extension sh --max-depth 3 | while read -r file; do
+ grep -q "nix flake update" "$file" && echo "$file" >>"$files_with_update"
+done
+
+if [ "$(wc -l <"$files_with_update")" != 0 ]; then
+ die "Some packages seem to try to update their flake with 'nix flake update'. This is redundant. These Packages are: $(echo && cat "$files_with_update")"
+fi
+
+# Than actually perform the update
+fd . --type directory --max-depth 1 | while read -r shard; do
+ cd "$shard" || die "(BUG): Shard '$shard' does not exist?"
+
+ fd . --type directory --max-depth 1 | while read -r package; do
+ cd "$package" || die "(BUG): Package '$package' does not exist?"
+
+ if [ -x update.sh ]; then
+ printf " \033[34;1m> \033[0m\033[34;1m%s\033[0m\n" "Running '${shard}${package}update.sh' .."
+
+ [ -f flake.nix ] && nix flake update
+
+ direnv allow
+ eval "$(direnv export bash 2>/dev/null)"
+ ./update.sh "$@"
+ fi
+ cd - >/dev/null || die "Bug: Last dir does not exist"
+ done
+ cd - >/dev/null || die "Bug: Last dir does not exist"
+done
+
+# vim: ft=sh